<html>
<head>
<title>OgreShaderFunction.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderFunction.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderFunction_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderProgramFunction_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderProgramFunction_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderParameter_8h.html">OgreShaderParameter.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderFunctionAtom_8h.html">OgreShaderFunctionAtom.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 <span class="keyword">namespace </span>RTShader {
<a name="l00036"></a>00036 
<a name="l00046"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html">00046</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RTShaderSystemAlloc</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="comment">// Interface.</span>
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccf">00050</a>     <span class="keyword">enum</span> <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccf">FunctionType</a>
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052         <span class="comment">// internal function (default)</span>
<a name="l00053"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccfa578ad928d998b23dc0428c05d18baa28">00053</a>         <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccfa578ad928d998b23dc0428c05d18baa28">FFT_INTERNAL</a>,
<a name="l00054"></a>00054         <span class="comment">// Vertex program main</span>
<a name="l00055"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccfa50c1ce1c691031b28bb844e91f698093">00055</a>         <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccfa50c1ce1c691031b28bb844e91f698093">FFT_VS_MAIN</a>,
<a name="l00056"></a>00056         <span class="comment">// Pixel shader main</span>
<a name="l00057"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccfa457e220621583f01a9dd833ea9788156">00057</a>         FFT_PS_MAIN
<a name="l00058"></a>00058     };
<a name="l00059"></a>00059 
<a name="l00061"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a9d9520c29d7ed740140ea79d70d42b84">00061</a>     <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;               <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a9d9520c29d7ed740140ea79d70d42b84" title="Get the name of this function.">getName</a>                 ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00062"></a>00062 
<a name="l00064"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a261d4d394712fccae894e199b4086381">00064</a>     <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;               <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a261d4d394712fccae894e199b4086381" title="Get the description of this function.">getDescription</a>          ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDescription; }
<a name="l00065"></a>00065 
<a name="l00074"></a>00074     <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>                resolveInputParameter   (<a class="code" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a> semantic, <span class="keywordtype">int</span> index,  <span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1Parameter.html#a4fa6286f097d19e92a8ed91645fbfbe7">Parameter::Content</a> content, <a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00085"></a>00085     <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>                resolveOutputParameter  (<a class="code" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a> semantic, <span class="keywordtype">int</span> index,  <span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1Parameter.html#a4fa6286f097d19e92a8ed91645fbfbe7">Parameter::Content</a> content, <a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type);
<a name="l00086"></a>00086 
<a name="l00094"></a>00094     <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>                resolveLocalParameter   (<a class="code" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a> semantic, <span class="keywordtype">int</span> index, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type);
<a name="l00095"></a>00095 
<a name="l00103"></a>00103     <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>                resolveLocalParameter   (<a class="code" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a> semantic, <span class="keywordtype">int</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1Parameter.html#a4fa6286f097d19e92a8ed91645fbfbe7">Parameter::Content</a> content, <a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type);
<a name="l00104"></a>00104     
<a name="l00105"></a>00105 
<a name="l00112"></a>00112     <span class="keyword">static</span> <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>             getParameterByName      (<span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp; parameterList, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00113"></a>00113 
<a name="l00121"></a>00121     <span class="keyword">static</span> <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>             getParameterBySemantic  (<span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp; parameterList, <span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a> semantic, <span class="keywordtype">int</span> index);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00131"></a>00131     <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>                    getParameterByContent   (<span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp; parameterList, <span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1Parameter.html#a4fa6286f097d19e92a8ed91645fbfbe7">Parameter::Content</a> content, <a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type);
<a name="l00132"></a>00132 
<a name="l00134"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#ae9cebaf2ffd969abb6e8354af75ba862">00134</a>     <span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp;      <a class="code" href="classOgre_1_1RTShader_1_1Function.html#ae9cebaf2ffd969abb6e8354af75ba862" title="Return a list of input parameters.">getInputParameters</a>      ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mInputParameters; }   
<a name="l00135"></a>00135 
<a name="l00137"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#aebc5c6bde8b66540224250540db98199">00137</a>     <span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp;      <a class="code" href="classOgre_1_1RTShader_1_1Function.html#aebc5c6bde8b66540224250540db98199" title="Return a list of output parameters.">getOutputParameters</a>     ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOutputParameters; }
<a name="l00138"></a>00138 
<a name="l00140"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a941e50e816084cded14db9ce881eae7a">00140</a>     <span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp;      <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a941e50e816084cded14db9ce881eae7a" title="Return a list of local parameters.">getLocalParameters</a>      ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLocalParameters; }   
<a name="l00141"></a>00141     
<a name="l00145"></a>00145     <span class="keywordtype">void</span>                            addAtomInstance         (<a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html" title="A class that represents an atomic code section of shader based program function.">FunctionAtom</a>* atomInstance);
<a name="l00146"></a>00146 
<a name="l00150"></a>00150     <span class="keywordtype">bool</span>                            deleteAtomInstance      (<a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html" title="A class that represents an atomic code section of shader based program function.">FunctionAtom</a>* atomInstance);
<a name="l00151"></a>00151 
<a name="l00153"></a>00153     <span class="keywordtype">void</span>                            sortAtomInstances       ();
<a name="l00154"></a>00154 
<a name="l00156"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a51a4f442e246120f3fc3beb20fe630a7">00156</a>     <a class="code" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">FunctionAtomInstanceList</a>&amp;       <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a51a4f442e246120f3fc3beb20fe630a7" title="Return list of atom instances composing this function.">getAtomInstances</a>        () { <span class="keywordflow">return</span> mAtomInstances; }
<a name="l00157"></a>00157 
<a name="l00159"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#ad3dfce24d0dd65234e7c6beef437efb0">00159</a>     <span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">FunctionAtomInstanceList</a>&amp; <a class="code" href="classOgre_1_1RTShader_1_1Function.html#ad3dfce24d0dd65234e7c6beef437efb0" title="Return list of atom instances composing this function.">getAtomInstances</a>        ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAtomInstances; }
<a name="l00160"></a>00160 
<a name="l00162"></a>00162     <span class="keywordtype">void</span>                        addInputParameter           (<a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter);
<a name="l00163"></a>00163 
<a name="l00165"></a>00165     <span class="keywordtype">void</span>                        addOutputParameter          (<a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter);
<a name="l00166"></a>00166 
<a name="l00168"></a>00168     <span class="keywordtype">void</span>                        deleteInputParameter        (<a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter);
<a name="l00169"></a>00169 
<a name="l00171"></a>00171     <span class="keywordtype">void</span>                        deleteOutputParameter       (<a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter);
<a name="l00172"></a>00172 
<a name="l00174"></a>00174     <span class="keywordtype">void</span>                        deleteAllInputParameters    ();
<a name="l00175"></a>00175 
<a name="l00177"></a>00177     <span class="keywordtype">void</span>                        deleteAllOutputParameters   ();
<a name="l00178"></a>00178 
<a name="l00180"></a>00180     FunctionType getFunctionType() <span class="keyword">const</span>;
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="keyword">protected</span>:
<a name="l00184"></a>00184 
<a name="l00190"></a>00190     <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>            (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, <span class="keyword">const</span> FunctionType functionType);
<a name="l00191"></a>00191 
<a name="l00193"></a>00193     ~<a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>           ();
<a name="l00194"></a>00194 
<a name="l00196"></a>00196     <span class="keywordtype">void</span>                        addParameter                (<a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp; parameterList, <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter);
<a name="l00197"></a>00197 
<a name="l00199"></a>00199     <span class="keywordtype">void</span>                        deleteParameter             (<a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp; parameterList, <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter);
<a name="l00200"></a>00200 
<a name="l00202"></a>00202     <span class="keyword">static</span> <span class="keywordtype">int</span>                  sAtomInstanceCompare        (<span class="keyword">const</span> <span class="keywordtype">void</span> * p0, <span class="keyword">const</span> <span class="keywordtype">void</span> *p1);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="keyword">protected</span>:
<a name="l00205"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a094815f70cb5d1dc976cc0e72a94ce5d">00205</a>     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>                      <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a094815f70cb5d1dc976cc0e72a94ce5d">mName</a>;                      <span class="comment">// Function name.</span>
<a name="l00206"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#adb5b7a84d6d0bc7d0c625c79d15620fc">00206</a>     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>                      <a class="code" href="classOgre_1_1RTShader_1_1Function.html#adb5b7a84d6d0bc7d0c625c79d15620fc">mDescription</a>;               <span class="comment">// Function description.</span>
<a name="l00207"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a288e02090c0387df9f36652dcb2c1ad7">00207</a>     <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>         <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a288e02090c0387df9f36652dcb2c1ad7">mInputParameters</a>;           <span class="comment">// Input parameters.</span>
<a name="l00208"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a0e5307d56647b477bf3eb4db4ce9836c">00208</a>     <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>         <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a0e5307d56647b477bf3eb4db4ce9836c">mOutputParameters</a>;          <span class="comment">// Output parameters.</span>
<a name="l00209"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#ab2b414b40e2432c58f0d3c35fb21d9cd">00209</a>     <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>         <a class="code" href="classOgre_1_1RTShader_1_1Function.html#ab2b414b40e2432c58f0d3c35fb21d9cd">mLocalParameters</a>;           <span class="comment">// Local parameters.</span>
<a name="l00210"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#ae30221805ee4e3ce4b76c2f1097fb909">00210</a>     <a class="code" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">FunctionAtomInstanceList</a>    <a class="code" href="classOgre_1_1RTShader_1_1Function.html#ae30221805ee4e3ce4b76c2f1097fb909">mAtomInstances</a>;             <span class="comment">// Atom instances composing this function.</span>
<a name="l00211"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a6eee88dac25aefd4bda8801c7cb39623">00211</a>     <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a147da0e3a9d408f20e8afcced1a15ccf">FunctionType</a>                <a class="code" href="classOgre_1_1RTShader_1_1Function.html#a6eee88dac25aefd4bda8801c7cb39623">mFunctionType</a>;              <span class="comment">// Function type</span>
<a name="l00212"></a>00212     
<a name="l00213"></a>00213 <span class="keyword">private</span>:
<a name="l00214"></a><a class="code" href="classOgre_1_1RTShader_1_1Function.html#a0432bf4ab621f4098afac914ccb5371e">00214</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>;
<a name="l00215"></a>00215 };
<a name="l00216"></a>00216 
<a name="l00217"></a><a class="code" href="group__RTShader.html#ga911c4514bf2ca43be16f14ab628d2e87">00217</a> <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Function*&gt;::type</a>                     <a class="code" href="group__RTShader.html#ga911c4514bf2ca43be16f14ab628d2e87">ShaderFunctionList</a>;
<a name="l00218"></a><a class="code" href="group__RTShader.html#ga91a7dab08d3a156422a3187fdb79f9d1">00218</a> <span class="keyword">typedef</span> ShaderFunctionList::iterator                <a class="code" href="group__RTShader.html#ga91a7dab08d3a156422a3187fdb79f9d1">ShaderFunctionIterator</a>;
<a name="l00219"></a><a class="code" href="group__RTShader.html#ga25959f998507ff542b6c6be42e295c2c">00219</a> <span class="keyword">typedef</span> ShaderFunctionList::const_iterator          <a class="code" href="group__RTShader.html#ga25959f998507ff542b6c6be42e295c2c">ShaderFunctionConstIterator</a>;
<a name="l00220"></a>00220 
<a name="l00224"></a>00224 }
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
